SOAP_ENVELOPE = 'http://schemas.xmlsoap.org/soap/envelope/'
SOAP_ENCCODING = "http://schemas.xmlsoap.org/soap/encoding/"

SOAP_ENVELOPE_NS_MAP = {'SOAP-ENV': SOAP_ENVELOPE}
PJM_EMKT_XMLNS = 'http://emkt.pjm.com/emkt/xml'
PJM_EMKT_URL_QUERY = "https://marketsgateway.pjm.com/marketsgateway/xml/query"
PJM_EMKT_URL_TRANSACTION = "https://marketsgateway.pjm.com/marketsgateway/xml/querybytransaction"

PJM_BASE_HEADERS = {
    'Host': 'marketsgateway.pjm.com',
    'SOAPAction': '/marketsgateway/xml/query',
    'Content-type': 'text/xml',
    'charset': 'UTF-8',
    'Accept': 'text/xml',
    'Cache-Control': 'no-cache',
    'Pragma': 'no-cache',
    'Cookie': '',
    'Content-length':  '0'
}

PJM_QUERY_REPORT_LIST = [
    'QueryBindingLimits',
    'QueryBidNodes',
    'QueryDemandBid',
    'QueryDemandSummary',
    'QueryDispatchLambda',
    'QueryDistributionFactors',
    'QueryDSRDetail',
    'QueryDSRRegistration',
    'QueryDSRRegulationOffer',
    'QueryDSRRegulationUpdate',
    'QueryDSRSRREGAward',
    'QueryDSRSchedules',
    'QueryDSRScheduleDefinitions',
    'QueryDSRScheduleDetail',
    'QueryDSRScheduleOffer',
    'QueryDSRScheduleOfferUpdate',
    'QueryDSRScheduleCompositeOffer',
    'QueryDSRScheduleSelection',
    'QueryDSRUpdate',
    'QueryInterfaceLimits',
    'QueryMarketPrices',
    'QueryMarketResults',
    'QueryMessages',
    'QueryNetTieSchedule',
    'QueryNodeList',
    'QueryPortfolios',
    'QueryRASchedMW',
    'QueryRegulationBilaterals',
    'QueryRegulationOffer',
    'QueryRegulationResults',
    'QueryRegulationUpdate',
    'QuerySchedReserveBilaterals',
    'QueryScheduleDefinitions',
    'QueryScheduleDetail',
    'QueryScheduleDetailUpdate',
    'QueryScheduleOffer',
    'QueryScheduleUpdate',
    'QueryScheduleOfferPriceCaps',
    'QueryScheduleCompositeOffer',
    'QueryScheduleSelection',
    'QueryScheduleSwitch',
    'QueryAllDSRScheduleDetail',
    'QueryAllDSRScheduleSelection',
    'QueryAllScheduleDetail',
    'QueryAllScheduleDetailUpdate',
    'QueryAllScheduleOffer',
    'QueryAllScheduleUpdate',
    'QueryAllScheduleSelection',
    'QueryAllScheduleAvailabilityUpdate',
    'QueryAllScheduleGasNomination',
    'QueryAllScheduleRestriction',
    'QueryThresholds',
    'QueryUnitDetail',
    'QueryUnitParameterLimit',
    'QueryExceptionParameterLimits',
    'QueryGetUnitParameterLimits',
    'QueryUnitSchedules',
    'QueryUnitUpdate',
    'QueryUnitRampRates',
    'QueryVirtualBid',
    'QueryWeatherForecast',
    'QueryIFPUnitUpdate',
    'QueryIFPUnitOffer',
    'QueryIFPAreaForecast',
    'QueryOPCFuelTypes',
    'QueryOPCOpportunityCosts',
    'QueryOPCUnitParameters',
    'QueryOPCDeliveredFuel',
    'QueryOPCDeliveredFuelMonthly',
    'QueryOPCOutages',
    'QueryOPCForecastedAllowance',
    'QueryUpToTransactions',
    'QueryNewUpToTransactionID',
    'QueryUpToTransactionResults',
    'QueryPseudoTieTransactions',
    'QueryPseudoTieTransactionResults',
    'QueryPRDResponseCurve',
    'QueryPRDHourly',
    'QueryWindForecast',
    'QueryDASchedMW',
    'QueryDemandBidCap',
    'QueryScheduleAvailabilityUpdate',
    'QueryScheduleGasNomination',
    'QueryScheduleRestriction',
    'QueryRTScheduleUseCost',
    'QueryFuelTypes',
    'QueryTPSScheduleSwitch',
    'QuerySolarForecast',
    'QueryUnitLimitations',
    'QueryFuelPriceExceptions',
    'QueryStorageUpdate',
    'QueryDASynchronizedReserveResults',
    'QueryRTSynchronizedReserveResults',
    'QueryDAPrimaryReserveResults',
    'QueryRTPrimaryReserveResults',
    'QueryDA30MinuteReserveResults',
    'QueryRT30MinuteReserveResults',
    'QueryNonSynchronizedReserveOffer',
    'QueryNonSynchronizedReserveUpdate',
    'QuerySecondaryReserveOffer',
    'QuerySecondaryReserveUpdate',
    'QuerySynchronizedReserveOffer',
    'QuerySynchronizedReserveUpdate',
    'QueryDSRSecondaryReserveOffer',
    'QueryDSRSecondaryReserveUpdate',
    'QueryDSRSynchronizedReserveOffer',
    'QueryDSRSynchronizedReserveUpdate',
    'QueryRegulationAward',
    'QueryDASynchronizedReserveAward',
    'QueryRTSynchronizedReserveAward',
    'QueryDANonSynchronizedReserveAward',
    'QueryDASecondaryReserveAward',
    'QueryRTSecondaryReserveAward',
    'QueryDSRRegulationAward',
    'QueryDSRDASynchronizedReserveAward',
    'QueryDSRRTSynchronizedReserveAward',
    'QueryDSRDASecondaryReserveAward',
    'QueryDSRRTSecondaryReserveAward',
    'QueryActiveSubzone',
    'QuerySecondaryReserveBilaterals',
    'QuerySynchronizedReserveBilaterals',
    'QueryNonSynchronizedReserveBilaterals'
]